%global namedreltag %{nil}
%global namedversion %{version}%{?namedreltag}

%if 0%{?fedora}
# https://bugzilla.redhat.com/show_bug.cgi?id=1289726
# https://issues.apache.org/jira/browse/BVAL-142
# https://issues.apache.org/jira/browse/WEAVER-10
%bcond_with commons-weaver
%endif

Name:          bval
Version:       1.1.1
Release:       7%{?dist}
Summary:       Apache Bean Validation
License:       ASL 2.0
Url:           http://bval.apache.org/
Source0:       http://www.apache.org/dist/bval/%{namedversion}/%{name}-parent-%{namedversion}-source-release.zip

BuildRequires: maven-local
BuildRequires: mvn(com.sun.xml.bind:jaxb-impl)
BuildRequires: mvn(com.thoughtworks.xstream:xstream)
BuildRequires: mvn(commons-beanutils:commons-beanutils-core)
BuildRequires: mvn(javax.annotation:javax.annotation-api)
BuildRequires: mvn(javax.el:javax.el-api)
BuildRequires: mvn(javax.enterprise:cdi-api)
BuildRequires: mvn(javax.inject:javax.inject)
BuildRequires: mvn(javax.validation:validation-api)
BuildRequires: mvn(javax.xml.bind:jaxb-api)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(org.apache:apache:pom:)
BuildRequires: mvn(org.apache.ant:ant)
BuildRequires: mvn(org.apache.commons:commons-lang3)
%if %{with commons-weaver}
BuildRequires: mvn(org.apache.commons:commons-weaver-privilizer)
BuildRequires: mvn(org.apache.commons:commons-weaver-privilizer-api)
BuildRequires: mvn(org.apache.commons:commons-weaver-processor)
BuildRequires: mvn(org.apache.commons:commons-weaver-maven-plugin)
%endif
BuildRequires: mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-interceptor_3.0_spec)
BuildRequires: mvn(org.apache.geronimo.specs:specs-parent:pom:)
BuildRequires: mvn(org.apache.maven.plugins:maven-antrun-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-enforcer-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-remote-resources-plugin)
BuildRequires: mvn(org.apache.rat:apache-rat-plugin)
BuildRequires: mvn(org.codehaus.mojo:buildnumber-maven-plugin)
BuildRequires: mvn(org.codehaus.mojo:jaxb2-maven-plugin)
BuildRequires: mvn(org.freemarker:freemarker)
BuildRequires: mvn(org.hibernate.javax.persistence:hibernate-jpa-2.1-api)
BuildRequires: mvn(org.mockito:mockito-core)
BuildRequires: mvn(xpp3:xpp3)

BuildArch:     noarch

%description
Apache BVal delivers an implementation of the Bean Validation
Specification (JSR-303 and JSR-346), which is TCK compliant and
works on Java SE 5 or later. The initial codebase for the
project was donated to the ASF by a SGA from Agimatec GmbH.

%package extras
Summary:       Apache BVal :: Extras

%description extras
BVal - non-JSR303 routines and constraints.

%package json
Summary:       Apache BVal :: JSON

%description json
BVal - Optional JSON Component.

%package jsr
Summary:       Apache BVal :: JSR 349

%description jsr
Implementation specific classes for JSR 349 Bean Validation 1.1.

%package parent
Summary:       Apache BVal :: Parent POM

%description parent
Apache BVal Parent POM.

%package xstream
Summary:       Apache BVal :: XStream

%description xstream
BVal XML Metadata with XStream.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}-parent-%{namedversion}
find . -name "*.class" -delete
find . -name "*.jar" -delete

%pom_disable_module bval-tck
# org.hibernate.beanvalidation.tck:beanvalidation-tck-tests:1.1.3.Final
%pom_disable_module bval-tck11
%pom_disable_module bundle

%pom_xpath_remove pom:Embed-Dependency bundle

%pom_remove_plugin -r :findbugs-maven-plugin
%pom_remove_plugin org.codehaus.mojo:ianal-maven-plugin
%pom_remove_plugin org.codehaus.mojo:jdepend-maven-plugin
%pom_remove_plugin -r :maven-source-plugin

# NoClassDefFoundError: org/xmlpull/v1/XmlPullParserFactory
%pom_add_dep xpp3:xpp3:1.1.4c:test %{name}-json
%pom_add_dep xpp3:xpp3:1.1.4c:test %{name}-xstream

%if %{without commons-weaver}
# Remove commons-weaver support
%pom_remove_plugin -r :commons-weaver-maven-plugin
%pom_remove_dep -r :commons-weaver-privilizer-api
sed -i '/Privilizing/d' \
 bval-core/src/main/java/org/apache/bval/model/MetaBean.java \
 bval-core/src/main/java/org/apache/bval/util/BValVersion.java \
 bval-core/src/main/java/org/apache/bval/util/FieldAccess.java \
 bval-core/src/main/java/org/apache/bval/util/MethodAccess.java \
 bval-core/src/main/java/org/apache/bval/util/reflection/Reflection.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/AnnotationConstraintBuilder.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/AnnotationProcessor.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/ApacheFactoryContext.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/ApacheValidatorFactory.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/BeanDescriptorImpl.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/ClassValidator.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/ConfigurationImpl.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/ConstraintAnnotationAttributes.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/ConstraintDefaults.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/DefaultMessageInterpolator.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/DefaultValidationProviderResolver.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/JsrMetaBeanFactory.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/resolver/DefaultTraversableResolver.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/xml/AnnotationProxyBuilder.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/xml/ValidationMappingParser.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/xml/ValidationParser.java \
 bval-xstream/src/main/java/org/apache/bval/xml/XMLMetaBeanManager.java
sed -i '/Privileged/d' \
 bval-jsr/src/main/java/org/apache/bval/jsr/AnnotationConstraintBuilder.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/ApacheValidatorFactory.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/ConfigurationImpl.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/xml/AnnotationProxyBuilder.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/xml/ValidationMappingParser.java \
 bval-jsr/src/main/java/org/apache/bval/jsr/xml/ValidationParser.java
%endif

%pom_change_dep -r :geronimo-annotation_1.2_spec javax.annotation:javax.annotation-api:1.2
%pom_change_dep -r :geronimo-atinject_1.0_spec javax.inject:javax.inject:1
%pom_change_dep -r :geronimo-interceptor_1.2_spec :geronimo-interceptor_3.0_spec
# https://bugzilla.redhat.com/show_bug.cgi?id=1276632
%pom_change_dep -r :geronimo-jcdi_1.1_spec javax.enterprise:cdi-api:1.1
%pom_change_dep -r :geronimo-jpa_2.0_spec org.hibernate.javax.persistence:hibernate-jpa-2.1-api:1.0.0.Draft-16

%pom_change_dep -r :tomcat-el-api javax.el:javax.el-api:3.0.0

%mvn_alias :bval-jsr :bval-jsr303
%mvn_package ":{*}::tests:" @1

%build

%mvn_build -s -- -Dri -Dproject.build.sourceEncoding=UTF-8

%install
%mvn_install 

%files -f .mfiles-%{name}-core
%doc CHANGES.txt README.txt RELEASE-NOTES.adoc
%license LICENSE NOTICE

%files extras -f .mfiles-%{name}-extras
%files json -f .mfiles-%{name}-json
%files jsr -f .mfiles-%{name}-jsr
%files parent -f .mfiles-%{name}-parent
%license LICENSE NOTICE
%files xstream -f .mfiles-%{name}-xstream

%files javadoc -f .mfiles-javadoc
%license LICENSE NOTICE

%changelog
* Thu Jan 31 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.1-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Thu Jul 12 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.1-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Jun 22 2016 gil cattaneo <puntogil@libero.it> 1.1.1-2
- regenerate build-requires

* Sun Feb 07 2016 gil cattaneo <puntogil@libero.it> 1.1.1-1
- update to 1.1.1

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.5-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Thu Jan 29 2015 gil cattaneo <puntogil@libero.it> 0.5-10
- introduce license macro

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri Mar 28 2014 Michael Simacek <msimacek@redhat.com> - 0.5-8
- Use Requires: java-headless rebuild (#1067528)

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Fri Jul 05 2013 gil cattaneo <puntogil@libero.it> 0.5-6
- fix unowned directory

* Fri Jul 05 2013 gil cattaneo <puntogil@libero.it> 0.5-5
- switch to XMvn
- minor changes to adapt to current guideline

* Sun Feb 17 2013 gil cattaneo <puntogil@libero.it> 0.5-4
- added missing BR geronimo-parent-poms

* Sun Feb 17 2013 gil cattaneo <puntogil@libero.it> 0.5-3
- added missing BR maven-local

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Mon Sep 24 2012 gil cattaneo <puntogil@libero.it> 0.5-1
- update to 0.5
- used pom macros

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Thu Jul 12 2012 gil cattaneo <puntogil@libero.it> 0.4-2
- Installed NOTICE file in javadoc package
- Fix preserve timestamps of installed POM files

* Tue May 15 2012 gil cattaneo <puntogil@libero.it> 0.4-1
- update to 0.4

* Fri Apr 06 2012 gil cattaneo <puntogil@libero.it> 0.3-1
- initial rpm
